//creeper mod by Mr. Wallet (BL_ID 688, JJWallet@gmail.com, steam login JJWallet@aol.com)
//props to rot, truce, redliub, zor, and all the helpful testers and suggesters, without whom this mod would not be the complete game that it is.

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs")) {
	if(!$RTB::RTBR_ServerControl_Hook) exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	RTB_registerPref("Non-Admins can set events","Creep Mod","Creep::EventsAllowed","bool","Game_Creeper",1,0,0,"CreepPrefOnChangeEventsAllowed");
	RTB_registerPref("Game Mode","Creep Mod","Creep::gamemode","list Standard 0 EndlessWaves 2 FreeSpawn 1","Game_Creeper",0,0,0,"CreepPrefOnChangeGameMode");	
	RTB_registerPref("Use Time Limit","Creep Mod","Creep::timerenabled","bool","Game_Creeper",1,0,0,"CreepPrefOnChangeTimerEnabled");	
	RTB_registerPref("Time Limit","Creep Mod","Creep::timelimit","int 1 30","Game_Creeper",5,0,0,"CreepPrefOnChangeTimeLimit");
	RTB_registerPref("Growth Speed","Creep Mod","Creep::tickms","list Normal 20 Slow 50 Slower 100 Slowest 200","Game_Creeper",20,0,0,"CreepPrefOnChangeCreepSpeed");
	RTB_registerPref("Player-Hunting","Creep Mod","Creep::wanderlust","list Laser-Guided 0 Merciless 1 Dogged 3 Pesky 9 Normal 19 Relaxed 49 Subtle 99 Off -1","Game_Creeper",19,0,0,"CreepPrefOnChangeCreepHunting");
	RTB_registerPref("Undulo Creeper","Creep Mod","Creep::undulo","bool","Game_Creeper",1,0,0,"CreepPrefOnChangeUndulo");
	RTB_registerPref("Creep Color","Creep Mod","Creep::Color","int 0 63","Game_Creeper",9,0,0,"CreepPrefOnChangeColor");
	RTB_registerPref("Color Mode","Creep Mod","Creep::ColorMode","list ShowDamage 0 Static 1","Game_Creeper",0,0,"CreepPrefOnChangeColorMode");
	RTB_registerPref("Damage Color Direction","Creep Mod","Creep::DmgDir","list Down 0 Up 1","Game_Creeper",0,0,0,"CreepPrefOnChangeColorDirection");
	RTB_registerPref("Damage Color Distance","Creep Mod","Creep::ColorDist","int 1 63","Game_Creeper",9,0,0,"CreepPrefOnChangeColorDistance");
	RTB_registerPref("Creep HP","Creep Mod","Creep::HPSetting","list Juggernautical 1 Unyielding 2 Hardy 3 Normal 4 Weak 5 Fragile 6 Insta-Gib 7","Game_Creeper",4,0,0,"CreepPrefOnChangeHPFactor");
	RTB_registerPref("Multiply HP by # of Players","Creep Mod","Creep::scalehp","bool","Game_Creeper",1,0,0,"CreepPrefOnChangeScaleHP");
	RTB_registerPref("Creep Regenerates","Creep Mod","Creep::regen","bool","Game_Creeper",1,0,0,"CreepPrefOnChangeRegenerates");
	RTB_registerPref("Regeneration Speed","Creep Mod","Creep::regenms","list Insane 150 Faster 425 Fast 750 Normal 1000 Slow 1500 Slower 2000","Game_Creeper",1000,0,0,"CreepPrefOnChangeRegenSpeed");
	RTB_addInfoTip("More creeper spawns don't make it grow faster! Only plant extras to make the game less predictable.", "", "Creep Mod");
	RTB_addInfoTip("Player-Hunting behavior can make the creeper seem faster by avoiding growth towards unpopulated areas.", "", "Creep Mod");
	RTB_addInfoTip("Find the creeper mod topic on the Blockland forums for a full manual or to leave suggestions!", "", "Creep Mod");
	RTB_addInfoTip("Creeper arenas should be tiny and not have dead-ends that the players can easily defend.", "", "Creep Mod");
	RTB_addInfoTip("Try playing Creep Mod in FreeSpawn mode and invent your own rules!", "", "Creep Mod");
	RTB_addInfoTip("Suppress bursts of creeper growth by damaging all the freshly-spawning bricks!", "", "Creep Mod");
	RTB_addInfoTip("Turning off a brick's raycasting lets creeper grow through it like it's not even there!", "", "Creep Mod");
	RTB_addInfoTip("The creeper won't grow on bricks that are not rendering; Use invisible bricks to keep the creeper growing through player-accessible areas!", "", "Creep Mod");
	RTB_addInfoTip("Invent your own creeper games using brick events like MiniGame->CreepKillAll and Self->CreepKillRadius!", "", "Creep Mod");
	RTB_addInfoTip("There's more than one creep-killing weapon; change the flavor of your minigame by changing up what your players can wield!", "", "Creep Mod");
} else {
	$Creep::EventsAllowed = 1;
	$Creep::gamemode = 0;
	$Creep::timerenabled = 1;
	$Creep::timelimit = 10;
	$Creep::tickms = 20;
	$Creep::wanderlust = 19;
	$Creep::undulo = 1;
	$Creep::Color = 9;
	$Creep::ColorMode = 0;
	$Creep::DmgDir = 0;
	$Creep::ColorDist = 9;
	$Creep::HPFactor = 1;
	$Creep::scalehp = 1;
	$Creep::regen = 1;
	$Creep::regenms = 1000;
}

switch($Creep::HPSetting) {
	case 1:
		$Creep::HPFactor = 100;
	case 2:
		$Creep::HPFactor = 2;
	case 3:
		$Creep::HPFactor = 1.5;
	case 4:
		$Creep::HPFactor = 1;
	case 5:
		$Creep::HPFactor = 0.67;
	case 6:
		$Creep::HPFactor = 0.33;
	case 7:
		$Creep::HPFactor = 0.01;
	default:
		$Creep::HPFactor = 1;
}

registerOutputEvent("MiniGame", "CreepKillAll", "", 1);
registerOutputEvent("fxDTSBrick", "CreepKillRadius", "float 0.5 100 0.5 10", 1);


function MiniGameSO::CreepKillAll(%obj, %client)
{
	if(!isobject(CreepGroup) || !$Creep::active) return;
	if(%client.minigame != CreepGroup.owner.minigame) return;
	for(%i = 0; %i < CreepGroup.getcount(); %i++) {
		CreepGroup.getobject(%i).killbrick();
	}
}

function fxDTSBrick::CreepKillRadius(%obj, %r, %client)
{
	if(!isobject(CreepGroup) || !$Creep::active) return;
	if(%client.minigame != CreepGroup.owner.minigame) return;
	initContainerRadiusSearch(%obj.position, %r, $TypeMasks::FxBrickObjectType);
	while(%check = containerSearchNext()) {
		if(CreepGroup.ismember(%check)) {
			%check.killbrick();
		}
	}
}

$GrowMasks = $TypeMasks::FxBrickObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::StaticShapeObjectType;

function CreepPrefOnChangeEventsAllowed(%old, %new)
{
	switch(%new) {
		case 1:
			%mode = "Anybody";
		default:
			%mode = "Only admins";
	}
	schedule(10, 0, "messageall", "", "\c3+ Creeper: \c5" @ %mode @ " \c0can set creeper-related brick events.");
}

function CreepPrefOnChangeGameMode(%old, %new)
{
	switch(%new) {
		case 0:
			%mode = "Standard";
		case 1:
			%mode = "Free Respawns";
		case 2:
			%mode = "Endless Waves";
		default:
			%mode = "LOLWUT ERROR";
	}
	schedule(10, 0, "messageall", "", "\c3+ Creeper: \c0game mode is now \c5" @ %mode);
}

function CreepPrefOnChangeTimerEnabled(%old, %new)
{
	switch(%new) {
		case 0:
			%mode = "Off";
		case 1:
			%mode = "On";
		default:
			%mode = "LOLWUT ERROR";
	}
	schedule(10, 0, "messageall", "", "\c3+ Creeper: \c0time limit is now \c5" @ %mode);
}

function CreepPrefOnChangeTimeLimit(%old, %new)
{
	if(!$Creep::TimeLimit) $Creep::TimeLimit = 1;
	schedule(10, 0, "messageall", "", "\c3+ Creeper: \c0time limit is now \c5" @ $Creep::TimeLimit @ " \c0minutes");
}

function CreepPrefOnChangeCreepSpeed(%old, %new)
{
	switch(%new) {
		case 20:
			%mode = "Normal";
		case 50:
			%mode = "Slow";
		case 100:
			%mode = "Slower";
		case 200:
			%mode = "Slowest";
		default:
			%mode = "Custom";
	}
	schedule(10, 0, "messageall", "", "\c3+ Creeper: \c0growth speed is now \c5" @ %mode);
}

function CreepPrefOnChangeCreepHunting(%old, %new)
{
	switch(%new) {
		case 0:
			%mode = "Laser-Guided";
		case 1:
			%mode = "Merciless";
		case 3:
			%mode = "Dogged";
		case 9:
			%mode = "Pesky";
		case 19:
			%mode = "Normal";
		case 49:
			%mode = "Relaxed";
		case 99:
			%mode = "Subtle";
		case -1:
			%mode = "Off";
		default:
			%mode = "Custom";
	}
	schedule(10, 0, "messageall", "", "\c3+ Creeper: \c0player-hunting attitude is now \c5" @ %mode);
}

function CreepPrefOnChangeUndulo(%old, %new)
{
	switch(%new) {
		case 0:
			%mode = "Off";
		case 1:
			%mode = "On";
		default:
			%mode = "LOLWUT ERROR";
	}
	schedule(10, 0, "messageall", "", "\c3+ Creeper: \c0creeper undulo is now \c5" @ %mode);
}

function CreepPrefOnChangeColor(%old, %new)
{
	schedule(10, 0, "messageall", "", "\c3+ Creeper: \c0color changed.");
}

function CreepPrefOnChangeColorMode(%old, %new)
{
	switch(%new) {
		case 0:
			%mode = "Show Damage";
		case 1:
			%mode = "Static";
		default:
			%mode = "LOLWUT ERROR";
	}
	schedule(10, 0, "messageall", "", "\c3+ Creeper: \c0color mode is now \c5" @ %mode);
}

function CreepPrefOnChangeColorDirection(%old, %new)
{
	schedule(10, 0, "messageall", "", "\c3+ Creeper: \c0direction reversed on color changes from damage.");
}

function CreepPrefOnChangeColorDistance(%old, %new)
{
	schedule(10, 0, "messageall", "", "\c3+ Creeper: \c5" @ %new @ " \c0colors before death (if color mode is \"Show Damage\".");
}

function CreepPrefOnChangeHPFactor(%old, %new)
{
	switch(%new) {
		case 1:
			%mode = "Juggernautical";
			$Creep::HPFactor = 100;
		case 2:
			%mode = "Unyielding";
			$Creep::HPFactor = 2;
		case 3:
			%mode = "Hardy";
			$Creep::HPFactor = 1.5;
		case 4:
			%mode = "Normal";
			$Creep::HPFactor = 1;
		case 5:
			%mode = "Weak";
			$Creep::HPFactor = 0.67;
		case 6:
			%mode = "Fragile";
			$Creep::HPFactor = 0.33;
		case 7:
			%mode = "Insta-Gib";
			$Creep::HPFactor = 0.01;
		default:
			%mode = "LOLWUT ERROR";
			$Creep::HPFactor = 1;
	}
	schedule(10, 0, "messageall", "", "\c3+ Creeper: \c0Creep HP is now \c5" @ %mode);
}

function CreepPrefOnChangeScaleHP(%old, %new)
{
	switch(%new) {
		case 0:
			%mode = "does not scale";
		case 1:
			%mode = "scales";
		default:
			%mode = "LOLWUT ERROR";
	}
	schedule(10, 0, "messageall", "", "\c3+ Creeper: \c0HP now \c5" @ %mode @ " \c0with number of players.");
}

function CreepPrefOnChangeRegenerates(%old, %new)
{
	switch(%new) {
		case 0:
			%mode = "Off";
		case 1:
			%mode = "On";
		default:
			%mode = "LOLWUT ERROR";
	}
	schedule(10, 0, "messageall", "", "\c3+ Creeper: \c0creeper regeneration is now \c5" @ %mode);
}

function CreepPrefOnChangeRegenSpeed(%old, %new)
{
	switch(%new) {
		case 2000:
			%mode = "Slower";
		case 1500:
			%mode = "Slow";
		case 1000:
			%mode = "Normal";
		case 750:
			%mode = "Fast";
		case 425:
			%mode = "Faster";
		case 150:
			%mode = "Insane";
		default:
			%mode = "Custom";
	}
	schedule(10, 0, "messageall", "", "\c3+ Creeper: \c0regeneration speed is now \c5" @ %mode);
}

datablock fxDTSBrickData (brick1x1CreepSpawnData : brick1x1Data){
	category = "Special";
	subCategory = "Creeper";
	uiName = "Creeper Spawn";
	iconName = "";
};

function brick1x1CreepSpawnData::onadd(%this,%brick)
{
	if(!isobject(CreepGroup)){
		new ScriptGroup(CreepGroup){
			class = Creeper;
		};
		mainBrickGroup.add(CreepGroup);
	}
	schedule(50,0,spawnadddelay,%brick);
	
}


function spawnadddelay(%brick)
{
	if(%brick.isplanted == 0 || !isobject(%brick)){
		return;
	}
	CreepGroup.add(%brick);
}


function brick1x1CreepSpawnData::onremove(%this,%brick)
{
	if(%brick.isplanted){
		CreepGroup.remove(%brick);
	
	   if(isObject(%obj.light))
	      %obj.light.delete();
	   if(isObject(%obj.emitter))
	      %obj.emitter.delete();
	   if(isObject(%obj.item))
	      %obj.item.delete();
	   if(isObject(%obj.AudioEmitter))
	      %obj.AudioEmitter.delete();
	   if(isObject(%obj.vehicle))
	      %obj.vehicle.delete();
	   if(isObject(%obj.vehicleSpawnMarker))
	    %obj.vehicleSpawnMarker.delete();

		if(isObject($CurrBrickKiller))
		{
		if(isObject($CurrBrickKiller.miniGame))
		{
		$CurrBrickKiller.incScore($CurrBrickKiller.miniGame.Points_BreakBrick);
		}
		}
	}
}

function ForceNewBrick(%datablock, %pos, %a, %color, %damage, %skipforce) {
	switch(%a) {
		case 0:
			%rot = "1 0 0 0";
		case 1:
			%rot = "0 0 1 90";
		case 2:
			%rot = "0 0 1 180";
		case 3:
			%rot = "0 0 1 -90";
	}
	%brick = new fxDTSBrick() {
			angleID = %a;
			colorFxID = "0";
			colorID = %color;
			dataBlock = %datablock;
			isPlanted = "1";
			position = %pos;
			printID = "0";
			rotation = %rot;
			scale = "1 1 1";
			shapeFxID = $Creep::undulo;
			damage = %damage;
	};
	%brick.plant();
	%brick.isBaseplate = "1";
	%brick.setTrusted(1);
	%brick.eventdelay0 = 0;
	%brick.eventenabled0 = 1;
	%brick.eventinput0 = "onPlayerTouch";
	%brick.eventinputidx0 = 1;
	%brick.eventoutput0 = "Kill";
	%brick.appendclient0 = 1;
	%brick.eventoutputidx0 = 1;
	%brick.eventtarget0 = "Player";
	%brick.eventtargetidx0 = 1;
	%brick.implicitcancelevents = 0;
	%brick.numevents = 1;
	%brick.justforced = true;
	if(!%skipforce) schedule(500,0,"unforcebrick",%brick);
	return %brick;
}

function unforceBrick(%brick)
{
	if(!isobject(%brick)) return;
	%brick.justforced = false;
}

function AttemptNewBrick(%datablock, %pos, %a, %color, %damage, %id) {
	switch(%a) {
		case 0:
			%rot = "1 0 0 0";
		case 1:
			%rot = "0 0 1 90";
		case 2:
			%rot = "0 0 1 180";
		case 3:
			%rot = "0 0 1 -90";
	}
	%brick = new fxDTSBrick() {
			angleID = %a;
			colorFxID = "0";
			colorID = %color;
			dataBlock = %datablock;
			position = %pos;
			printID = "0";
			rotation = %rot;
			isplanted = "1";
			scale = "1 1 1";
			shapeFxID = $Creep::undulo;
			damage = %damage;
			stackbl_id = %id;
	};
	%brick.client = findclientbybl_id(%id);
	%brick.plant();
	schedule(50, 0, "FinishBrickPlantStuff", %brick, %id);
	return(%brick);
}

function FinishBrickPlantStuff(%brick)
{
	if(!isobject(%brick)) return;
	CreepGroup.add(%brick);
	%brick.setTrusted(1);
	return;
	%brick.eventdelay0 = 0;
	%brick.eventenabled0 = 1;
	%brick.eventinput0 = "onPlayerTouch";
	%brick.eventinputidx0 = 1;
	%brick.eventoutput0 = "Kill";
	%brick.appendclient0 = 1;
	%brick.eventoutputidx0 = 1;
	%brick.eventtarget0 = "Player";
	%brick.eventtargetidx0 = 1;
	%brick.implicitcancelevents = 0;
	%brick.numevents = 1;
}

function GrowTick(%counter)
{
	cancel($CreepGrowTick);
	if(!isobject(CreepGroup.owner.minigame)) {
		messageall("", "Minigame aborted.");
		servercmdendcreepgame(CreepGroup.owner);
		return;
	}
	if(!CreepGroup.getcount()) {
		messageall("", "The creep has been exterminated; humans win!");
		if($Creep::gamemode != 2) servercmdendcreepgame(CreepGroup.owner);
		else creepwaveover();
		return;
	}
	CreepGroup.grow();
	%counter++;
	if(%counter >= 10) {
		%counter = 0;
		%lose = CheckForSurvivors(CreepGroup.owner.minigame);
		if(%lose) return;
	}
	CreepGroup.optimize(%counter);
	if($Creep::tickms < 20) $Creep::tickms = 20;
	$CreepGrowTick = schedule($Creep::tickms, 0, "GrowTick", %counter);
}

function Creeper::IdealCreeping(%this, %pos)
{
	%check = ContainerRayCast(%pos, getword(%pos, 0) SPC getword(%pos, 1) SPC (getword(%pos, 2)+0.2), $GrowMasks);
	if(isobject(%check)) return false;
	%check = ContainerRayCast(%pos, getword(%pos, 0) SPC getword(%pos, 1) SPC (getword(%pos, 2)-0.2), $GrowMasks);
	if(isobject(%check)) return false;
	for(%x = 0; %x <= 2; %x++) {
		for(%y = 0; %y <= 2; %y++) {
			for(%z = 0; %z <= 2; %z++) {
				if(((%x == 1 && (%y == 1 || %z == 1)) || (%z == 1 && %y == 1)) && (%x != 1 || %y != 1 || %z != 1)) {
					%check = ContainerRayCast(%pos, vectoradd(%pos, ((%x-1)*0.7) SPC ((%y-1)*0.7) SPC ((%z-1)*0.8)), $GrowMasks);
					if(isobject(%check) && !%this.ismember(%check)) {
						if(%check.getclassname() $= "fxDTSBrick") {
							if(%check.isrendering()) return true;
						} else return true;
					}
				}
			}
		}
	}
	return false;
}

function Creeper::GoodCreeping(%this, %pos)
{
	%check = ContainerRayCast(%pos, getword(%pos, 0) SPC getword(%pos, 1) SPC (getword(%pos, 2)+0.2), $GrowMasks);
	if(isobject(%check)) return false;
	%check = ContainerRayCast(%pos, getword(%pos, 0) SPC getword(%pos, 1) SPC (getword(%pos, 2)-0.2), $GrowMasks);
	if(isobject(%check)) return false;
	for(%x = 0; %x <= 2; %x++) {
		for(%y = 0; %y <= 2; %y++) {
			for(%z = 0; %z <= 2; %z++) {
				if(%z == 1) {
					%vec = ((%x-1)*0.7) SPC ((%y-1)*0.7) SPC "0";
					%check = ContainerRayCast(%pos, vectoradd(%pos, %vec), $GrowMasks);
				} else {
					if(%x != 1 || %y != 1) {
						%vec = ((%x-1)*0.5) SPC ((%y-1)*0.5) SPC "0";
						%glance = ContainerRayCast(%pos, vectoradd(%pos, %vec), $GrowMasks);
					}
					if(!isobject(%glance) || (%x == 1 && %y == 1)) {
						%vec = "0 0" SPC ((%z-1)*0.8);
						%tpos = (getword(%pos, 0)+((%x-1)*0.5)) SPC (getword(%pos, 1)+((%y-1)*0.5)) SPC getword(%pos, 2);
						%check = ContainerRayCast(%tpos, vectoradd(%tpos, %vec), $GrowMasks);
					}
				}
				if(isobject(%check) && !%this.ismember(%check)) {
					if(%check.getclassname() $= "fxDTSBrick") {
						if(%check.isrendering()) return true;
					} else return true;
				}
			}
		}
	}
	return false;
}

function SetCreepDmgColor(%brick)
{
	if($Creep::ColorMode) return;
	if(!%brick.damage) {
		%brick.setcolor($Creep::Color);
		return;
	}
	%damlimit = ((15 - (CreepGroup.getcount()/1000)));
	if(%damlimit < 0) %damlimit = 0;
	%damlimit = (%damlimit + 5) * ($Creep::scalehp ? CreepGroup.owner.minigame.playercount : 1) * $Creep::HPFactor;
	%damlimit += mfloor(%damlimit * (CreepGroup.owner.minigame.wave - 1) * 0.2);
	%damstep = %damlimit / $Creep::ColorDist + 1;
	if($Creep::DmgDir) {
		%color = $Creep::Color + mceil(%brick.damage/%damstep);
		if(%color > 63) %color -= 64;
	} else {
		%color = mfloor((%damlimit - %brick.damage)/%damstep) + $Creep::Color - $Creep::ColorDist;
		if(%color < 0) %color += 64;
	}
	%brick.setcolor(%color);
}

function BrickRegen(%brick)
{
	if(!isobject(%brick)) return;
	%brick.damage--;
	if(%brick.damage < 0) %brick.damage = 0;
	SetCreepDmgColor(%brick);
	if(%brick.damage > 0) %brick.regentick = schedule($Creep::regenms, 0, "BrickRegen", %brick);
}

function Creeper::Grow(%this)
{
	%this.searchrad++;
	if($Creep::wanderlust >= 0 && !getrandom(0,$Creep::wanderlust)) {
		for(%i = 0; %i < %this.owner.minigame.nummembers; %i++) {
			%creepfound = false;
			%pl = %this.owner.minigame.member[%i].player;
			if(isobject(%pl) && %pl.getdatablock().getname() $= "CreeperArmor") {
				initContainerRadiusSearch(%pl.getposition(), 9 + %this.searchrad, $TypeMasks::FxBrickObjectType);
				while(!%creepfound && %check = containerSearchNext()) {
					if(%this.ismember(%check) && !%check.isdead() && !%check.cantgrow) {
						%creepfound = true;
						%checkindex++;
						%checklist[%checkindex] = %check;
					}
				}
			}
		}
	}
	if(%checkindex) {
		for(%i = 1; %i <= %checkindex && !isobject(%brick); %i++) {
			%brick = %this.trytogrowbrick(%checklist[%i]);
			//if(%brick == 3) echo("FUCK ME");
		}
		if(isobject(%brick) && !%brick.isdead()) {
			for(%j = 1; %j <= 5 && !%sorted; %j++) {
				if(!isobject(%this.priority[%j])) {
					%this.priority[%j] = %brick;
					%sorted = true;
				}
			}
			if(!%sorted) {
				for(%j = 5; %j > 1 ; %j--) {
					%this.priority[%j] = %this.priority[%j - 1];
				}
				%this.priority[1] = %brick;
			}
			%planted = true;
		}
		%this.searchrad -= 2;
		if(%this.searchrad < 0) %this.searchrad = 0;
		if(%planted) return;
	}
	%this.genericgrowth();
}

function Creeper::GenericGrowth(%this)
{
	for(%i = 1; %i <= 10; %i++) {
		if(!isObject(%this.priority[%i])) %brick = %this.getobject(getrandom(0,%this.getcount()-1));
		else %brick = %this.priority[%i];
		if(%brick.damage <= 0 && !%brick.isdead()) {
		//if(%color $= "") %color = 9;
			%pos = %brick.getposition();
			%x = getword(%pos, 0);
			%y = getword(%pos, 1);
			%z = getword(%pos, 2);
			%db = %brick.getdatablock();
			%bsx = (%brick.angleid % 2 == 0 ? %db.bricksizex : %db.bricksizey);
			%bsy = (%brick.angleid % 2 == 0 ? %db.bricksizey : %db.bricksizex);
			if(!%brick.cantgrow) {
				%brick.cantgrow = true;
				for(%j = 1; %j <= %bsx; %j++) {
					for(%k = 1; %k <= %bsy; %k++) {
						for(%l = 1; %l <= %db.bricksizez/3; %l++) {
							%tmpx = %x - ((%bsx - 1) * 0.25) + ((%j - 1) * 0.5);
							%tmpy = %y - ((%bsy - 1) * 0.25) + ((%k - 1) * 0.5);
							%tmpz = %z - ((%db.bricksizez/3 - 1) * 0.3) + ((%l - 1) * 0.6);
							%tmppos = %tmpx SPC %tmpy SPC %tmpz;
							if((%j == 1 && (%k == 1 || %l == 1)) || (%k == 1 && %l == 1)) {
								if(%l == 1) {
									%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0 -0.85"), $GrowMasks);
									if(!%outcheck && %this.idealcreeping(vectoradd(%tmppos, "0 0 -0.6"))) {
										%brick.cantgrow = false;
										%index++;
										%poslist[%index] = vectoradd(%tmppos, "0 0 -0.6");
									}
								}
								if(%brick.cantgrow) {
									if(%j == 1) {
										%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "-0.65 0 0"), $GrowMasks);
										if(!%outcheck && %this.idealcreeping(vectoradd(%tmppos, "-0.5 0 0"))) {
											%index++;
											%poslist[%index] = vectoradd(%tmppos, "-0.5 0 0");
											%brick.cantgrow = false;
										}
									}
									if(%j == %bsx) {
										%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0.65 0 0"), $GrowMasks);
										if(!%outcheck && %this.idealcreeping(vectoradd(%tmppos, "0.5 0 0"))) {
											%index++;
											%poslist[%index] = vectoradd(%tmppos, "0.5 0 0");
											%brick.cantgrow = false;
										}
									}
									if(%k == 1) {						
										%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 -0.65 0"), $GrowMasks);
										if(!%outcheck && %this.idealcreeping(vectoradd(%tmppos, "0 -0.5 0"))) {
											%index++;
											%poslist[%index] = vectoradd(%tmppos, "0 -0.5 0");
											%brick.cantgrow = false;
										}
									}
									if(%k == %bsy) {
										%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0.65 0"), $GrowMasks);
										if(!%outcheck && %this.idealcreeping(vectoradd(%tmppos, "0 0.5 0"))) {
											%index++;
											%poslist[%index] = vectoradd(%tmppos, "0 0.5 0");
											%brick.cantgrow = false;
										}
									}
									if(%l == %db.bricksizez/3) {
										%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0 0.85"), $GrowMasks);
										if(!%outcheck && %this.idealcreeping(vectoradd(%tmppos, "0 0 0.6"))) {
											if(getrandom(0,1)) {
												%index++;
												%poslist[%index] = vectoradd(%tmppos, "0 0 0.6");
											}
											%brick.cantgrow = false;
										}
									}
								}
							}
							if(%brick.cantgrow) {
								if(%l == 1) {
									%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0 -0.85"), $GrowMasks);
									if(!%outcheck && %this.goodcreeping(vectoradd(%tmppos, "0 0 -0.6"))) {
										%brick.cantgrow = false;
										%index++;
										%poslist[%index] = vectoradd(%tmppos, "0 0 -0.6");
									}
								}
								if(%brick.cantgrow) {
									if(%j == 1) {
										%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "-0.65 0 0"), $GrowMasks);
										if(!%outcheck && %this.goodcreeping(vectoradd(%tmppos, "-0.5 0 0"))) {
											%index++;
											%poslist[%index] = vectoradd(%tmppos, "-0.5 0 0");
											%brick.cantgrow = false;
										}
									}
									if(%j == %bsx) {
										%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0.65 0 0"), $GrowMasks);
										if(!%outcheck && %this.goodcreeping(vectoradd(%tmppos, "0.5 0 0"))) {
											%index++;
											%poslist[%index] = vectoradd(%tmppos, "0.5 0 0");
											%brick.cantgrow = false;
										}
									}
									if(%k == 1) {						
										%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 -0.65 0"), $GrowMasks);
										if(!%outcheck && %this.goodcreeping(vectoradd(%tmppos, "0 -0.5 0"))) {
											%index++;
											%poslist[%index] = vectoradd(%tmppos, "0 -0.5 0");
											%brick.cantgrow = false;
										}
									}
									if(%k == %bsy) {
										%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0.65 0"), $GrowMasks);
										if(!%outcheck && %this.goodcreeping(vectoradd(%tmppos, "0 0.5 0"))) {
											%index++;
											%poslist[%index] = vectoradd(%tmppos, "0 0.5 0");
											%brick.cantgrow = false;
										}
									}
									if(%l == %db.bricksizez/3) {
										%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0 0.85"), $GrowMasks);
										if(!%outcheck && %this.goodcreeping(vectoradd(%tmppos, "0 0 0.6"))) {
											if(getrandom(0,1)) {
												%index++;
												%poslist[%index] = vectoradd(%tmppos, "0 0 0.6");
											}
											%brick.cantgrow = false;
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	if(!%index) return;
	%datablock = "brick1x1Data";
	%rnd = getrandom(1, %index);
	%brick = forceNewBrick(%datablock, %poslist[%rnd], 0, $Creep::Color);
	%this.add(%brick);
	if(isobject(%brick)) {
		%sorted = false;
		for(%i = 1; %i <= 5 && !%sorted; %i++) {
			if(!isobject(%this.priority[%i])) {
				%this.priority[%i] = %brick;
				%sorted = true;
			}
		}
		if(!%sorted) {
			for(%i = 5; %i > 1 ; %i--) {
				%this.priority[%i] = %this.priority[%i - 1];
			}
			%this.priority[1] = %brick;
		}
	}
	return %brick;
}

function Creeper::TryToGrowBrick(%this, %brick)
{
	if(%brick.damage > 0 || !isobject(%brick)) return;
	//if(%color $= "") %color = 9;
	%pos = %brick.getposition();
	%x = getword(%pos, 0);
	%y = getword(%pos, 1);
	%z = getword(%pos, 2);
	%db = %brick.getdatablock();
	%bsx = (%brick.angleid % 2 == 0 ? %db.bricksizex : %db.bricksizey);
	%bsy = (%brick.angleid % 2 == 0 ? %db.bricksizey : %db.bricksizex);
	if(!%brick.cantgrow) {
		%brick.cantgrow = true;
		for(%j = 1; %j <= %bsx; %j++) {
			for(%k = 1; %k <= %bsy; %k++) {
				for(%l = 1; %l <= %db.bricksizez/3; %l++) {
					%tmpx = %x - ((%bsx - 1) * 0.25) + ((%j - 1) * 0.5);
					%tmpy = %y - ((%bsy - 1) * 0.25) + ((%k - 1) * 0.5);
					%tmpz = %z - ((%db.bricksizez/3 - 1) * 0.3) + ((%l - 1) * 0.6);
					%tmppos = %tmpx SPC %tmpy SPC %tmpz;
					if((%j == 1 && (%k == 1 || %l == 1)) || (%k == 1 && %l == 1)) {
						if(%l == 1) {
							%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0 -0.85"), $GrowMasks);
							if(!%outcheck && %this.idealcreeping(vectoradd(%tmppos, "0 0 -0.6"))) {
								%brick.cantgrow = false;
								%index++;
								%poslist[%index] = vectoradd(%tmppos, "0 0 -0.6");
							}
						}
						if(%brick.cantgrow) {
							if(%j == 1) {
								%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "-0.65 0 0"), $GrowMasks);
								if(!%outcheck && %this.idealcreeping(vectoradd(%tmppos, "-0.5 0 0"))) {
									%index++;
									%poslist[%index] = vectoradd(%tmppos, "-0.5 0 0");
									%brick.cantgrow = false;
								}
							}
							if(%j == %bsx) {
								%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0.65 0 0"), $GrowMasks);
								if(!%outcheck && %this.idealcreeping(vectoradd(%tmppos, "0.5 0 0"))) {
									%index++;
									%poslist[%index] = vectoradd(%tmppos, "0.5 0 0");
									%brick.cantgrow = false;
								}
							}
							if(%k == 1) {						
								%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 -0.65 0"), $GrowMasks);
								if(!%outcheck && %this.idealcreeping(vectoradd(%tmppos, "0 -0.5 0"))) {
									%index++;
									%poslist[%index] = vectoradd(%tmppos, "0 -0.5 0");
									%brick.cantgrow = false;
								}
							}
							if(%k == %bsy) {
								%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0.65 0"), $GrowMasks);
								if(!%outcheck && %this.idealcreeping(vectoradd(%tmppos, "0 0.5 0"))) {
									%index++;
									%poslist[%index] = vectoradd(%tmppos, "0 0.5 0");
									%brick.cantgrow = false;
								}
							}
							if(%l == %db.bricksizez/3) {
								%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0 0.85"), $GrowMasks);
								if(!%outcheck && %this.idealcreeping(vectoradd(%tmppos, "0 0 0.6"))) {
									if(getrandom(0,1)) {
										%index++;
										%poslist[%index] = vectoradd(%tmppos, "0 0 0.6");
									}
									%brick.cantgrow = false;
								}
							}
						}
					}
					if(%brick.cantgrow) {
						if(%l == 1) {
							%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0 -0.85"), $GrowMasks);
							if(!%outcheck && %this.goodcreeping(vectoradd(%tmppos, "0 0 -0.6"))) {
								%brick.cantgrow = false;
								%index++;
								%poslist[%index] = vectoradd(%tmppos, "0 0 -0.6");
							}
						}
						if(%brick.cantgrow) {
							if(%j == 1) {
								%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "-0.65 0 0"), $GrowMasks);
								if(!%outcheck && %this.goodcreeping(vectoradd(%tmppos, "-0.5 0 0"))) {
									%index++;
									%poslist[%index] = vectoradd(%tmppos, "-0.5 0 0");
									%brick.cantgrow = false;
								}
							}
							if(%j == %bsx) {
								%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0.65 0 0"), $GrowMasks);
								if(!%outcheck && %this.goodcreeping(vectoradd(%tmppos, "0.5 0 0"))) {
									%index++;
									%poslist[%index] = vectoradd(%tmppos, "0.5 0 0");
									%brick.cantgrow = false;
								}
							}
							if(%k == 1) {						
								%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 -0.65 0"), $GrowMasks);
								if(!%outcheck && %this.goodcreeping(vectoradd(%tmppos, "0 -0.5 0"))) {
									%index++;
									%poslist[%index] = vectoradd(%tmppos, "0 -0.5 0");
									%brick.cantgrow = false;
								}
							}
							if(%k == %bsy) {
								%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0.65 0"), $GrowMasks);
								if(!%outcheck && %this.goodcreeping(vectoradd(%tmppos, "0 0.5 0"))) {
									%index++;
									%poslist[%index] = vectoradd(%tmppos, "0 0.5 0");
									%brick.cantgrow = false;
								}
							}
							if(%l == %db.bricksizez/3) {
								%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0 0.85"), $GrowMasks);
								if(!%outcheck && %this.goodcreeping(vectoradd(%tmppos, "0 0 0.6"))) {
									if(getrandom(0,1)) {
										%index++;
										%poslist[%index] = vectoradd(%tmppos, "0 0 0.6");
									}
									%brick.cantgrow = false;
								}
							}
						}
					}
				}
			}
		}
	}
	if(!%index) return -1; //return; alone was somehow always returning a value of dummyPlayer, causing massive console spam.
	%datablock = "brick1x1Data";
	%rnd = getrandom(1, %index);
	%brick = forceNewBrick(%datablock, %poslist[%rnd], 0, $Creep::Color);
	%this.add(%brick);
	return %brick;
}

function Creeper::Optimize(%this, %step)
{
	switch(%step) {
		case 0:
			for(%i = 0; %i <= %this.getcount()/2; %i++) {
				%brick = %this.getobject(%i);
				if(%brick.getdatablock().getname() $= "brick1x1Data" && %brick.cantgrow < 2) {
					if(%brick.cantgrow) %brick.cantgrow = 2;
					%pos = %brick.getposition();
					%y = getword(%pos, 1);
					if((%y * 4) % 4 $= "1") {
						%x = getword(%pos, 0);
						%z = getword(%pos, 2);
						initcontainerboxsearch(%x SPC (%y+0.5) SPC %z, "0.05 0.05 0.05", $TypeMasks::FxBrickObjectType);
						if(%oneup = containersearchnext()) {
							if(%this.ismember(%oneup) && %oneup.getdatablock().getname() $= "brick1x1Data") {
								%y = (%y + getword(%oneup.getposition(), 1)) / 2;
								%dmg = mceil((%brick.damage + %oneup.damage) / 2);
								for(%i = 1; %i <= 5; %i++) {
									if(%this.priority[%i] == %brick || %this.priority[%i] == %oneup) {
										if(!%newp1) %newp1 = %i;
										else %newp2 = %i;
									}
								}
								%skipforce = !(%brick.justforced || %oneup.justforced);
								%brick.delete();
								%oneup.delete();
								%new = forceNewBrick("brick1x2Data", %x SPC %y SPC %z, 0, $Creep::Color, %skipforce);
								%new.damage = %dmg;
								if(%dmg > 0) {
									SetCreepDmgColor(%new);
									if($Creep::regen) %new.regentick = schedule($Creep::regenms, 0, "BrickRegen", %new);
								}
								%this.add(%new);
								if(%newp1) {
									%this.priority[%newp1] = %new;
									if(%newp2) %this.priority[%newp2] = %new;
								}
							}
						}
					}
				}
			}
		case 5:
			for(%i = %this.getcount() - 1; %i > %this.getcount()/2; %i--) {
				if(%i >= %this.getcount()) %i = %this.getcount() - 1;
				%brick = %this.getobject(%i);
				if(%brick.getdatablock().getname() $= "brick1x1Data" && %brick.cantgrow < 2) {
					if(%brick.cantgrow) %brick.cantgrow = 2;
					%pos = %brick.getposition();
					%y = getword(%pos, 1);
					if((%y * 4) % 4 $= "1") {
						%x = getword(%pos, 0);
						%z = getword(%pos, 2);
						initcontainerboxsearch(%x SPC (%y+0.5) SPC %z, "0.05 0.05 0.05", $TypeMasks::FxBrickObjectType);
						if(%oneup = containersearchnext()) {
							if(%this.ismember(%oneup) && %oneup.getdatablock().getname() $= "brick1x1Data") {
								%y = (%y + getword(%oneup.getposition(), 1)) / 2;
								%dmg = mceil((%brick.damage + %oneup.damage) / 2);
								for(%i = 1; %i <= 5; %i++) {
									if(%this.priority[%i] == %brick || %this.priority[%i] == %oneup) {
										if(!%newp1) %newp1 = %i;
										else %newp2 = %i;
									}
								}
								%skipforce = !(%brick.justforced || %oneup.justforced);
								%brick.delete();
								%oneup.delete();
								%new = forceNewBrick("brick1x2Data", %x SPC %y SPC %z, 0, $Creep::Color, %skipforce);
								%new.damage = %dmg;
								if(%dmg > 0) {
									SetCreepDmgColor(%new);
									if($Creep::regen) %new.regentick = schedule($Creep::regenms, 0, "BrickRegen", %new);
								}
								%this.add(%new);
								if(%newp1) {
									%this.priority[%newp1] = %new;
									if(%newp2) %this.priority[%newp2] = %new;
								}
							}
						}
					}
				}
			}
		case 1:
			for(%i = 0; %i < %this.getcount(); %i++) {
				%brick = %this.getobject(%i);
				if(%brick.getdatablock().getname() $= "brick1x2Data" && %brick.cantgrow < 2) {
					if(%brick.cantgrow) %brick.cantgrow = 2;
					%pos = %brick.getposition();
					%x = getword(%pos, 0);
					%y = getword(%pos, 1);
					%z = getword(%pos, 2);
					if((%x * 4) % 4 $= "1") {
						initcontainerboxsearch((%x+0.5) SPC %y SPC %z, "0.05 0.05 0.05", $TypeMasks::FxBrickObjectType);
						if(%oneup = containersearchnext()) {
							if(%this.ismember(%oneup) && %oneup.getdatablock().getname() $= "brick1x2Data") {
								%x = (%x + getword(%oneup.getposition(), 0)) / 2;
								%dmg = mceil((%brick.damage + %oneup.damage) / 2);
								for(%i = 1; %i <= 5; %i++) {
									if(%this.priority[%i] == %brick || %this.priority[%i] == %oneup) {
										if(!%newp1) %newp1 = %i;
										else %newp2 = %i;
									}
								}
								%skipforce = !(%brick.justforced || %oneup.justforced);
								%brick.delete();
								%oneup.delete();
								%new = forceNewBrick("brick2x2Data", %x SPC %y SPC %z, 0, $Creep::Color, %skipforce);
								%new.damage = %dmg;
								if(%dmg > 0) {
									SetCreepDmgColor(%new);
									if($Creep::regen) %new.regentick = schedule($Creep::regenms, 0, "BrickRegen", %new);
								}
								%this.add(%new);
								if(%newp1) {
									%this.priority[%newp1] = %new;
									if(%newp2) %this.priority[%newp2] = %new;
								}
							}
						}
					}
				}
			}
		case 2:
			for(%i = 0; %i < %this.getcount(); %i++) {
				%brick = %this.getobject(%i);
				if(%brick.getdatablock().getname() $= "brick2x2Data" && %brick.cantgrow < 2) {
					if(%brick.cantgrow) %brick.cantgrow = 2;
					%pos = %brick.getposition();
					%x = getword(%pos, 0);
					%y = getword(%pos, 1);
					%z = getword(%pos, 2);
					if((%y * 2) % 4 $= "1") {
						initcontainerboxsearch(%x SPC (%y+1) SPC %z, "0.05 0.05 0.05", $TypeMasks::FxBrickObjectType);
						if(%oneup = containersearchnext()) {
							if(%this.ismember(%oneup) && %oneup.getdatablock().getname() $= "brick2x2Data") {
								%y = (%y + getword(%oneup.getposition(), 1)) / 2;
								%dmg = mceil((%brick.damage + %oneup.damage) / 2);
								for(%i = 1; %i <= 5; %i++) {
									if(%this.priority[%i] == %brick || %this.priority[%i] == %oneup) {
										if(!%newp1) %newp1 = %i;
										else %newp2 = %i;
									}
								}
								%skipforce = !(%brick.justforced || %oneup.justforced);
								%brick.delete();
								%oneup.delete();
								%new = forceNewBrick("brick2x4Data", %x SPC %y SPC %z, 0, $Creep::Color, %skipforce);
								%new.damage = %dmg;
								if(%dmg > 0) {
									SetCreepDmgColor(%new);
									if($Creep::regen) %new.regentick = schedule($Creep::regenms, 0, "BrickRegen", %new);
								}
								%this.add(%new);
								if(%newp1) {
									%this.priority[%newp1] = %new;
									if(%newp2) %this.priority[%newp2] = %new;
								}
							}
						}
					}
				}
			}
		case 3:
			for(%i = 0; %i < %this.getcount(); %i++) {
				%brick = %this.getobject(%i);
				if(%brick.getdatablock().getname() $= "brick2x4Data" && %brick.cantgrow < 2) {
					if(%brick.cantgrow) %brick.cantgrow = 2;
					%pos = %brick.getposition();
					%x = getword(%pos, 0);
					%y = getword(%pos, 1);
					%z = getword(%pos, 2);
					if((%x * 2) % 4 $= "1") {
						initcontainerboxsearch((%x+1) SPC %y SPC %z, "0.05 0.05 0.05", $TypeMasks::FxBrickObjectType);
						if(%oneup = containersearchnext()) {
							if(%this.ismember(%oneup) && %oneup.getdatablock().getname() $= "brick2x4Data") {
								%x = (%x + getword(%oneup.getposition(), 0)) / 2;
								%dmg = mceil((%brick.damage + %oneup.damage) / 2);
								for(%i = 1; %i <= 5; %i++) {
									if(%this.priority[%i] == %brick || %this.priority[%i] == %oneup) {
										if(!%newp1) %newp1 = %i;
										else %newp2 = %i;
									}
								}
								%skipforce = !(%brick.justforced || %oneup.justforced);
								%brick.delete();
								%oneup.delete();
								%new = forceNewBrick("brick4x4Data", %x SPC %y SPC %z, 0, $Creep::Color, %skipforce);
								%new.damage = %dmg;
								if(%dmg > 0) {
									SetCreepDmgColor(%new);
									if($Creep::regen) %new.regentick = schedule($Creep::regenms, 0, "BrickRegen", %new);
								}
								%this.add(%new);
								if(%newp1) {
									%this.priority[%newp1] = %new;
									if(%newp2) %this.priority[%newp2] = %new;
								}
							}
						}
					}
				}
			}
		case 6:
			for(%i = 0; %i < %this.getcount(); %i++) {
				%brick = %this.getobject(%i);
				if(%brick.getdatablock().getname() $= "brick4x8Data" && !%brick.cantgrow) {
					%pos = %brick.getposition();
					%x = getword(%pos, 0);
					%y = getword(%pos, 1);
					%z = getword(%pos, 2);
					if(%x % 8 $= "2") {
						initcontainerboxsearch((%x+2) SPC %y SPC %z, "0.05 0.05 0.05", $TypeMasks::FxBrickObjectType);
						if(%oneup = containersearchnext()) {
							if(%this.ismember(%oneup) && %oneup.getdatablock().getname() $= "brick4x8Data") {
								%x = (%x + getword(%oneup.getposition(), 0)) / 2;
								%dmg = mceil((%brick.damage + %oneup.damage) / 2);
								for(%i = 1; %i <= 5; %i++) {
									if(%this.priority[%i] == %brick || %this.priority[%i] == %oneup) {
										if(!%newp1) %newp1 = %i;
										else %newp2 = %i;
									}
								}
								%skipforce = !(%brick.justforced || %oneup.justforced);
								%brick.delete();
								%oneup.delete();
								%new = forceNewBrick("brick8x8Data", %x SPC %y SPC %z, 0, $Creep::Color, %skipforce);
								%new.damage = %dmg;
								if(%dmg > 0) {
									SetCreepDmgColor(%new);
									if($Creep::regen) %new.regentick = schedule($Creep::regenms, 0, "BrickRegen", %new);
								}
								%this.add(%new);
								if(%newp1) {
									%this.priority[%newp1] = %new;
									if(%newp2) %this.priority[%newp2] = %new;
								}
							}
						}
					}
				}
			}
		case 7:
			for(%i = 0; %i < %this.getcount(); %i++) {
				%brick = %this.getobject(%i);
				if(%brick.getdatablock().getname() $= "brick1x1Data" && %brick.cantgrow == 2) {
					%pos = %brick.getposition();
					%x = getword(%pos, 0);
					if((%x * 4) % 4 $= "1") {
						%y = getword(%pos, 1);
						%z = getword(%pos, 2);
						initcontainerboxsearch((%x+0.5) SPC %y SPC %z, "0.05 0.05 0.05", $TypeMasks::FxBrickObjectType);
						if(%oneup = containersearchnext()) {
							if(%this.ismember(%oneup) && %oneup.getdatablock().getname() $= "brick1x1Data" && %oneup.cantgrow == 2) {
								%x = (%x + getword(%oneup.getposition(), 0)) / 2;
								%dmg = mceil((%brick.damage + %oneup.damage) / 2);
								for(%i = 1; %i <= 5; %i++) {
									if(%this.priority[%i] == %brick || %this.priority[%i] == %oneup) {
										if(!%newp1) %newp1 = %i;
										else %newp2 = %i;
									}
								}
								%skipforce = !(%brick.justforced || %oneup.justforced);
								%brick.delete();
								%oneup.delete();
								%new = forceNewBrick("brick1x2Data", %x SPC %y SPC %z, 1, $Creep::Color, %skipforce);
								%new.damage = %dmg;
								if(%dmg > 0) {
									SetCreepDmgColor(%new);
									if($Creep::regen) %new.regentick = schedule($Creep::regenms, 0, "BrickRegen", %new);
								}
								%this.add(%new);
								if(%newp1) {
									%this.priority[%newp1] = %new;
									if(%newp2) %this.priority[%newp2] = %new;
								}
							}
						}
					}
				}
			}
		case 8:
			for(%i = 0; %i < %this.getcount(); %i++) {
				%brick = %this.getobject(%i);
				if(%brick.getdatablock().getname() $= "brick1x2Data" && %brick.angleid == 1) {
					%pos = %brick.getposition();
					%x = getword(%pos, 0);
					if((%x * 2) % 4 $= "1") {
						%y = getword(%pos, 1);
						%z = getword(%pos, 2);
						initcontainerboxsearch((%x+1) SPC %y SPC %z, "0.05 0.05 0.05", $TypeMasks::FxBrickObjectType);
						if(%oneup = containersearchnext()) {
							if(%this.ismember(%oneup) && %oneup.getdatablock().getname() $= "brick1x2Data" && %oneup.angleid == 1) {
								%x = (%x + getword(%oneup.getposition(), 0)) / 2;
								%dmg = mceil((%brick.damage + %oneup.damage) / 2);
								for(%i = 1; %i <= 5; %i++) {
									if(%this.priority[%i] == %brick || %this.priority[%i] == %oneup) {
										if(!%newp1) %newp1 = %i;
										else %newp2 = %i;
									}
								}
								%skipforce = !(%brick.justforced || %oneup.justforced);
								%brick.delete();
								if(isobject(%oneup)) %oneup.delete();
								%new = forceNewBrick("brick1x4Data", %x SPC %y SPC %z, 1, $Creep::Color, %skipforce);
								%new.damage = %dmg;
								if(%dmg > 0) {
									SetCreepDmgColor(%new);
									if($Creep::regen) %new.regentick = schedule($Creep::regenms, 0, "BrickRegen", %new);
								}
								%this.add(%new);
								if(%newp1) {
									%this.priority[%newp1] = %new;
									if(%newp2) %this.priority[%newp2] = %new;
								}
							}
						}
					}
				}
			}
		case 9:
			for(%i = 0; %i < CreepGroup.owner.minigame.nummembers; %i++) {
				%cl = CreepGroup.owner.minigame.member[%i];
				if(isobject(%cl.player)) %cl.player.addvelocity("0 0 0.01");
			}
	}
}

function reviveNeighborCells(%brick)
{
	%pos = %brick.getposition();
	%x = getword(%pos, 0);
	%y = getword(%pos, 1);
	%z = getword(%pos, 2);
	%db = %brick.getdatablock();
	%bsx = (%brick.angleid % 2 == 0 ? %db.bricksizex : %db.bricksizey);
	%bsy = (%brick.angleid % 2 == 0 ? %db.bricksizey : %db.bricksizex);
	for(%j = 1; %j <= %bsx; %j++) {
		for(%k = 1; %k <= %bsy; %k++) {
			for(%l = 1; %l <= %db.bricksizez/3; %l++) {
				%tmpx = %x - ((%bsx - 1) * 0.25) + ((%j - 1) * 0.5);
				%tmpy = %y - ((%bsy - 1) * 0.25) + ((%k - 1) * 0.5);
				%tmpz = %z - ((%db.bricksizez/3 - 1) * 0.3) + ((%l - 1) * 0.6);
				%tmppos = %tmpx SPC %tmpy SPC %tmpz;						
				if(%l == 1) {
					%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0 -0.85"), $GrowMasks);
					if(isobject(%outcheck) && CreepGroup.ismember(%outcheck)) %outcheck.cantgrow = false;
				}
				if(%brick.cantgrow) {
					if(%j == 1) {
						%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "-0.65 0 0"), $GrowMasks);
						if(isobject(%outcheck) && CreepGroup.ismember(%outcheck)) %outcheck.cantgrow = false;
					}
					if(%j == %bsx) {
						%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0.65 0 0"), $GrowMasks);
						if(isobject(%outcheck) && CreepGroup.ismember(%outcheck)) %outcheck.cantgrow = false;
					}
					if(%k == 1) {						
						%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 -0.65 0"), $GrowMasks);
						if(isobject(%outcheck) && CreepGroup.ismember(%outcheck)) %outcheck.cantgrow = false;
					}
					if(%k == %bsy) {
						%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0.65 0"), $GrowMasks);
						if(isobject(%outcheck) && CreepGroup.ismember(%outcheck)) %outcheck.cantgrow = false;
					}
					if(%l == %db.bricksizez/3) {
						%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0 0.85"), $GrowMasks);
						if(isobject(%outcheck) && CreepGroup.ismember(%outcheck)) %outcheck.cantgrow = false;
					}
				}
			}
		}
	}
}

function Creeper::startGrowth(%this, %client)
{
	$Creep::SavedSpawns[index] = 0;
	%this.searchrad = 0;
	for(%i = 0; %i < CreepGroup.getcount(); %i++) {
		%spawn = %this.getobject(%i);
		if(%spawn.getdatablock().getname() $= "brick1x1CreepSpawnData") {
			$Creep::SavedSpawns[index]++;
			%pos = %spawn.getposition();
			$Creep::SavedSpawns[$Creep::SavedSpawns[index]] = %pos;
			$Creep::SavedSpawns[$Creep::SavedSpawns[index], color] = %spawn.colorid;
			$Creep::SavedSpawns[$Creep::SavedSpawns[index], blid] = %spawn.stackbl_id;
			%brick = forceNewBrick("brick1x1Data", %pos, 0, $Creep::Color);
			%this.add(%brick);
			%spawn.delete();
		}
	}
	if($Creep::tickms < 20) $Creep::tickms = 20;
	return schedule($Creep::tickms, 0, "GrowTick");
}

datablock PlayerData(CreeperArmor : PlayerStandardArmor)
{
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	maxitems = 10;
	maxtools = 5;
	maxweapons = 5;
	cameramaxdist = 2;
	cameramindist = 0;
	uiName = "Creeper Game Mode";
	showEnergyBar = false;
};

function CreeperArmor::ondisabled(%this, %obj)
{
	parent::ondisabled(%this,%obj);
	if($Creep::active && %obj.client.minigame == CreepGroup.owner.minigame) {
		%lose = CheckForSurvivors(CreepGroup.owner.minigame);
		if(%lose) return;
		schedule(100, 0, "freefly", %obj.client);
	}
}

function freefly(%client)
{
	%client.camera.setflymode();
}

datablock ParticleData(CreepKillTrailParticle)
{
	dragCoefficient		= 0.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 200;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;	
	//framesPerSec		= 1;

	textureName		= "base/data/particles/thinRing";

	// Interpolation variables
	colors[0]	= "0 1 0.3 1.0";
	colors[1]	= "0.2 0.4 0.2 1";
	colors[2]	= "0.1 0.1 0.1 1";
	sizes[0]	= 0.1;
	sizes[1]	= 0.1;
	sizes[2]	= 0.05;
	times[0]	= 0.0;
	times[1]	= 0.1;
	times[2]	= 1;
};

datablock ParticleData(CreepSprayTrailParticle)
{
	dragCoefficient		= 0.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 1.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 550;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;	
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";

	// Interpolation variables
	colors[0]	= "0.3 0.6 0.3 1.0";
	colors[1]	= "0.3 0.6 0.3 1.0";
	colors[2]	= "0.3 0.6 0.3 1.0";
	sizes[0]	= 0.1;
	sizes[1]	= 0.1;
	sizes[2]	= 0.1;
	times[0]	= 0.0;
	times[1]	= 1;
	times[2]	= 10;
	times[3]	= 10; //console error :?
};

datablock ParticleEmitterData(CreepKillTrailEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = CreepKillTrailParticle;

   useEmitterColors = true;
};

datablock ParticleEmitterData(CreepSprayEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;

   ejectionVelocity = 10; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 0.0;  

   particles = CreepSprayTrailParticle;

   useEmitterColors = true;
   uiName = "CreepSpray Trail";
};

datablock ParticleData(CreepKillExplosionParticle : stablePaintExplosionParticle) 
{
	colors[0] = "0.3 0.6 0.3 1";
	colors[1] = "0.3 0.6 0.3 1";
	colors[2] = "0.3 0.6 0.3 1";
	colors[3] = "1 1 1 1";
};

datablock ParticleEmitterData(CreepKillExplosionEmitter : stablePaintExplosionEmitter)
{
	particles = "CreepKillExplosionParticle";
};

datablock ExplosionData(CreepKillExplosion : stablePaintExplosion)
{
	emitter[0] = "CreepKillExplosionEmitter";
	emitter[1] = "";//"stablePaintDropletEmitter";
};

datablock ProjectileData(CreepKillProjectile : stablePaintProjectile)
{
   directDamage        = 0;
   impactImpulse       = 1300;
   verticalImpulse     = 1300;
   explosion           = CreepKillExplosion;
   particleEmitter     = CreepKillTrailEmitter;

   muzzleVelocity      = 40;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 275;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   
   uiName = "Creep Kill";
   
   creepDamage = 5;
};

datablock ProjectileData(CreepSprayProjectile : CreepKillProjectile)
{
	gravitymod = 1;
	muzzleVelocity = 10;
   isBallistic = true;
   lifetime = 550;
   uiName = "Creep Spray";
   particleEmitter = "";
   creepDamage = 5;
};

datablock ItemData(CreepKillGunItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "base/data/shapes/printGun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;

	uiName = "CreepKill";
	iconName = "";
	doColorShift = true;
	colorShiftColor = "0.3 0.8 1 1.000";

	image = CreepKillGunImage;
	canDrop = true;
};

datablock ItemData(CreepSprayGunItem : CreepKillGunItem)
{
	shapefile = "./Exterminator_Tank.dts";
	colorShiftColor = "0.3 0.6 0.3 1.0";
	doColorShift = true;

	uiName = "CreepSpray";
	image = CreepSprayGunImage;
	iconName = "./icon_Exterminator";
};

datablock ShapeBaseImageData(CreepKillGunImage : stableSprayCanImage)
{
   shapeFile = "base/data/shapes/printGun.dts";
   emap = false;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.7 1.2 -0.55";
   eyeRotation = "1 0 0 0";
   rotation = "1 0 0 0";

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = CreepKillGunItem;
   ammo = " ";
   projectile = CreepKillProjectile;
   projectileType = Projectile;
   melee = false;

   doColorShift = true;
   colorShiftColor = CreepKillGunItem.colorShiftColor;
   statetimeoutvalue[2] = 0.1;
   stateemitter[2] = "";
   stateemittertime[2] = "0";
   statesound[0] = "";
   //statesound[2] = "sprayFireSound";
};

datablock ShapeBaseImageData(CreepSprayGunImage : CreepKillGunImage)
{
	shapefile = "./Exterminator_Tank.dts";
   colorShiftColor = CreepSprayGunItem.colorShiftColor;
	
   offset = "0 0 0";
   eyeOffset = "0.17 -0.02 -1.66";
   eyeRotation = "1 0 0 0";
   rotation = "1 0 0 0";
   melee = false;
   
   
   correctMuzzleVector = true;
	
	item = CreepSprayGunItem;
	projectile = CreepSprayProjectile;
	statetimeoutvalue[2] = 0.05;
	StateEmitter[2] = CreepSprayEmitter;
	StateEmitterNode[2] = muzzleNode;
	StateEmitterTime[2] = 0.05;
};

function CreepKillProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
{
	if(!isobject(CreepGroup)) return;
	if(CreepGroup.ismember(%c) && $Creep::Active && !CreepGroup.owner.minigame.betweenwaves && Creepgroup.owner.minigame == %b.sourceobject.client.minigame) {
		if(iseventpending(%c.regentick)) cancel(%c.regentick);
		%c.damage += %a.creepdamage;
		%b.sourceobject.client.points += %a.creepdamage;
		if(%c.justforced) {
			%c.justforced = 0;
			%b.sourceobject.client.points += %a.creepdamage;
		}
		%damlimit = ((15 - (CreepGroup.getcount()/1000)));
		if(%damlimit < 0) %damlimit = 0;
		%damlimit = (%damlimit + 5) * ($Creep::scalehp ? CreepGroup.owner.minigame.playercount : 1) * $Creep::HPFactor;
		%damlimit += mfloor(%damlimit * (CreepGroup.owner.minigame.wave - 1) * 0.2);
		if(%c.damage >= %damlimit) {
			%c.killbrick();
			%b.sourceobject.client.kills++;
			%b.sourceobject.client.points += 25;
		} else {
			SetCreepDmgColor(%c);
			if($Creep::regen) %c.regentick = schedule($Creep::regenms, 0, "BrickRegen", %c);
		}
	}
}

function CreepSprayProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
{
	CreepKillProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g);
}

package CreeperPackage
{	
	function gettrustlevel(%a, %b)
	{
		if(isobject(CreepGroup)) {
			if((creepgroup.ismember(%a) || creepgroup.ismember(%b)) && (getbrickgroupfromobject(%a).client.isadmin || getbrickgroupfromobject(%b).client.isadmin)) return 3;
		}
		parent::gettrustlevel(%a, %b);
	}
	
	function servercmdAddEvent(%client, %subject, %input, %dunno, %target, %idk, %output, %a, %b, %c, %d, %e, %f, %g)
	{
		%targtxt = getword($InputEvent_TargetListfxDTSBrick_[%input], %target*2);
		%creepoutputs = "CreepKillAll CreepKillRadius";
		if(!%client.isadmin && !$Creep::EventsAllowed && strpos(%creepoutputs, $OutputEvent_Name[%targtxt, %output]) != -1) {
			centerprint(%client, "", "Only admins can set creep-related events on this server.", 3, 3);
			return;
		}
		Parent::servercmdAddEvent(%client, %subject, %input, %dunno, %target, %idk, %output, %a, %b, %c, %d, %e, %f, %g);
	}
	
	function creeper::add(%this, %add, %count)
	{
		if(%this.getname() $= "CreepGroup" && isobject(%add)) {
			if(%add.getdatablock() $= "") {
				%count++;
				if(%count < 2) %this.schedule(50, "add", %add, %count);
				return;
			} else if(%add.getdatablock().getname() $= "brick1x1CreepSpawnData" || $Creep::Active) parent::add(%this, %add);
		} else parent::add(%this, %add);
	}
	
	function gameconnection::spawnplayer(%client)
	{
		if($Creep::Active && $Creep::gamemode != 1 && %client.minigame == CreepGroup.owner.minigame && !%client.minigame.betweenwaves && !%client.leavingmini) {
			%client.setcontrolobject(%client.camera);
			freefly(%client);
			return;
		}
		parent::spawnplayer(%client);
	}
	
	function serverCmdLeaveMinigame(%client)
	{
		Parent::serverCmdLeaveMinigame(%client);
		if(!isobject(%client.player)) %client.spawnplayer();
	}
	
	function serverCmdPlantBrick(%client)
	{
		if($Creep::Active && isobject(%client.player.tempbrick) && creepgroup.owner.minigame == %client.minigame) {
			messageclient(%client, "", "\c7Sorry, construction during a creep survival game is not yet supported.");
			return;
		} else if(isobject(%client.player.tempbrick)) {
			if(%client.player.tempbrick.getdatablock().getname() $= "brick1x1CreepSpawnData" && !%client.isadmin) {
				messageclient(%client, "", "\c7Only admins can plant creep spawns.");
				return;
			}
		}
		parent::serverCmdPlantBrick(%client);
	}
	
	function fxdtsbrick::ondeath(%a, %b, %c, %d, %e, %f, %g)
	{
		if(isobject(CreepGroup)) {
			if(CreepGroup.ismember(%a) && $Creep::Active) reviveNeighborCells(%a);
		}
		parent::ondeath(%a, %b, %c, %d, %e, %f, %g);
	}
};
activatepackage(CreeperPackage);

function CheckForSurvivors(%minigame)
{
	if($Creep::gamemode == 1) return false;
	%lose = true;
	if(isobject(%minigame)) {
		for(%i = 0; %i < %minigame.nummembers && %lose; %i++) {
			%obj = %minigame.member[%i].getcontrolobject();
			if(isobject(%obj)) {
				if(%minigame.member[%i].getcontrolobject().getdatablock().getname() $= "CreeperArmor") %lose = false;
			}
		}
	}
	if(%lose) {
		messageall("", "No surviving humans; the creeper thrives!");
		servercmdendcreepgame(CreepGroup.owner);
	}
	return(%lose);
}


function ServerCmdNewCreepGame(%client)
{
	if(!CreepGroup.getcount()) {
		messageclient(%client,'',"There are no creep spawns");
		return;
	}
	if(%client.startedcreepalready == 1){ 
		messageclient(%client,'',"Make sure you're super admin and you're the one who created the minigame.");
		return;
	}
	if(%client.minigame != 0){
		if(%client.isadmin){
			if(%client.minigame.member0 = %client){
				if($Creep::gamemode == 2 && $Creep::timerenabled != 1) {
					messageclient(%client,'',"Endless Waves game mode requires a time limit for each wave.");
					return;
				}
				CreepGroup.owner = %client;
				CreepGroup.owner.minigame.wave = 1;
				for(%i = 0; %i < clientgroup.getcount(); %i++) {
					%cl = clientgroup.getobject(%i);
					if(%cl.minigame == %client.minigame) {
						if(isobject(%cl.player)) {
							if(isobject(%cl.player.tempbrick)) %cl.player.tempbrick.delete();
						}
						%cl.spawnplayer();
					}
					%cl.points = 0;
					%cl.kills = 0;
				}
				%client.minigame.playercount = %client.minigame.nummembers;
				messageclient(%client,'',"\c4Creep game started");
				if($Creep::GameMode == 2) {
					messageall("", "\c5Wave 1");
				}
				%client.startedcreepalready = 1;
				$Creep::active = 1;
				timer(%client.minigame);
				$CreepGrowTick = CreepGroup.startgrowth(%client);
			}
		}
	}
}

function timer(%minigame)
{
	if($Creep::active == 0) return;
	if($Creep::timerenabled == 1){
		if(iseventpending($creepgametimer)) cancel($creepgametimer);
		%minigame.timeelapsed += 1000;
		%timeleft = ($Creep::timelimit * 60000) - %minigame.timeelapsed;
		$creepgametimer = schedule(1000,0,"timer",%minigame);
		if(%timeleft > 60000) {
			if(%timeleft % 60000 == 0) {
				Centerprintall("<just:center>\c3" @ %timeleft/60000 SPC "minutes left.",3);
			}
		} else if(%timeleft > 10000 && %timeleft <= 60000) {
			if(%timeleft % 10000 == 0) {
				Centerprintall("<just:center>\c3" @ %timeleft/1000 SPC "seconds left!",3);
			}
		} else if(%timeleft > 0 && %timeleft <= 10000) {
			Centerprintall("<just:center>\c3" @ %timeleft/1000 SPC "seconds left!",3);
		} else {
			Centerprintall("",3);
			messageall("","\c3Time over; Humans have survived!");
			if($Creep::gamemode != 2) servercmdendcreepgame(%minigame.member0);
			else creepwaveover();
		}
	}
}

function servercmdendcreepgame(%client)
{
	if(%client.isadmin && $Creep::active == 1)
	{
		cancel($creepgametimer);
		cancel($CreepGrowTick);
		%client.startedcreepalready = 0;
		$Creep::active = 0;
		CreepGroup.minigame.wave = 0;
		%client.minigame.timeelapsed = 0;
		messageclient(%client,'',"Creep game ended.");
		CreepGroup.deleteall();
		for(%i = 0; %i < CreepGroup.owner.minigame.nummembers; %i++) {
			%cl = CreepGroup.owner.minigame.member[%i];
			if(!isobject(%cl.player)) %cl.spawnplayer();
			else if($Creep::timerenabled) %cl.points += 200 * $Creep::timelimit;
			if(%cl.points $= "") %cl.points = "0";
			if(%cl.kills $= "") %cl.kills = "0";
			messageall("", "\c2" @ %cl.name @ "\c6: " @ %cl.points @ " points \c7(" @ %cl.kills @ " kills)");
		}
		for(%i = 1; %i <= $Creep::SavedSpawns[index]; %i++) {
			%new = AttemptNewBrick("brick1x1CreepSpawnData", $Creep::SavedSpawns[%i], 0, $Creep::SavedSpawns[%i, color], $Creep::SavedSpawns[%i, blid]);
		}
	}
}

function creepwaveover()
{
	cancel($creepgametimer);
	cancel($CreepGrowTick);
	CreepGroup.owner.minigame.betweenwaves = true;
	for(%i = 0; %i < CreepGroup.owner.minigame.nummembers; %i++) {
		%cl = CreepGroup.owner.minigame.member[%i];
		if(isobject(%cl.player)) %cl.points += 200 * $Creep::timelimit;
	}
	CreepGroup.deleteall();
	for(%i = 1; %i <= $Creep::SavedSpawns[index]; %i++) {
		%new = AttemptNewBrick("brick1x1CreepSpawnData", $Creep::SavedSpawns[%i], 0, $Creep::SavedSpawns[%i, color], $Creep::SavedSpawns[%i, blid]);
	}
	centerprintall("\c5Next wave in 5 seconds...", 5, 3);
	$creepgametimer = schedule(5000, 0, "nextcreepwave");
}

function nextcreepwave()
{
	if(!isobject(creepgroup)) return;
	for(%i = 0; %i < CreepGroup.owner.minigame.nummembers; %i++) {
		%cl = CreepGroup.owner.minigame.member[%i];
		%cl.spawnplayer();
	}
	if(!CreepGroup.getcount()) {
		messageclient(CreepGroup.owner,'',"There are no creep spawns!");
		servercmdendcreepgame(CreepGroup.owner);
		return;
	}
	CreepGroup.owner.minigame.playercount = CreepGroup.owner.minigame.nummembers;
	CreepGroup.owner.minigame.wave++;
	CreepGroup.owner.minigame.timeelapsed = 0;
	messageall("", "\c5Wave " @ CreepGroup.owner.minigame.wave);
	timer($Creep::timelimit,0,CreepGroup.owner.minigame);
	CreepGroup.owner.minigame.betweenwaves = false;
	$CreepGrowTick = CreepGroup.startgrowth(CreepGroup.owner);
}